#include <sys/io.h>
#include <unistd.h>

#include "tcpip.h"
#include "play.h"
#include "main.h"
#include "door.h"

/* Copyright (C) 1992,2000 Bisqwit (http://iki.fi/bisqwit/) *
 * No warranty. License: see file COPYING.                  */

static __inline__ unsigned char inportb(const unsigned short port)
{
   unsigned char _v;
   __asm__ volatile ("inb %1,%0"
             :"=a" (_v)
             :"d" ((unsigned short)port));
   return _v;
}

static __inline__ void outportb(const unsigned short port,
                                const unsigned char value)
{
   __asm__ volatile ("outb %0,%1"
             ::"a" ((char) value),"d" ((unsigned short) port));
}

extern void FlushaaSanomus(void);
static void OviSoi(void)
{
	int Sock;
	printf("%-22s %20s\n", kello(), "Ovikello");
	if(log)fprintf(log,  "%-22s %20s\n", kello(), "Ovikello");
	
	InitPlay(16, 27000);
	
	/* Play("nz40:3,30,10:t255v64{mtcpcpcp>c,l8ms<<c.<aaa>f,vzl6>>>cp12<fp12<c}p12"); */
	/* Play("nz200:3,190:3,140:2,100:t255ms<{<vzl16f+f+f+>f+,>>>>l15v0f+1pf+1pf+1pc+1}"); */
	/* Play("nz200:3,190:3,140:2,100:t255ms<{vzl16f+f+f+>v50f+8>>>>l15v0f+1pf+1pf+1}"); */
	Play("na229:2,180:2,120:2,80:2,60:3,50:3,30:3,10:nb60:2,0:ms t140 l8 va <{fff>f30,vbmsl6>>>>cagbgef}");
	DonePlay();
	FlushaaSanomus();
	Sock = ConnectOut("10.0.0.4", 9875, 1000000);
	if(Sock >= 0)
	{
		write(Sock, "bell", 4);
		close(Sock);
	}
}

void DoorInit(void)
{
	ioperm(0x378, 2, 1);
	outportb(0x378, 0x00);
}

void DoorCheck(void)
{
	static int delay = 0;
	unsigned char a = inportb(0x379);
	if(!(a&8))
	{
		if(delay > 0)
			delay--;
		else
		{
			OviSoi();
			delay=20;
		}
	}
}
