/* This file is used by lptkikka and hepuli */

#include <sys/wait.h>

const char cachefile[] = "/var/run/hepulicache";
int sanottu=0;

void FlushaaSanomus(void)
{
	int p = fork();
	int status;
	if(p < 0)return;
	
	if(!p)
	{
		close(0);
		close(1);
		p = dup(2);
		close(2);
		setenv("HOME", "/root", 1);
		execl("/usr/local/bin/esdcat",
		      "esdcat",
		      "-m", "-r", "27000",
		      cachefile,
		      NULL);
		dup2(p, 2);
		perror("Could not exec");
		_exit(-1);
	}
	waitpid(p, &status, 0);
	
	if(WIFEXITED(status))
	{
	    status = WEXITSTATUS(status);
	    if(!status)
	        sanottu = 0;
	    else
	        printf("esdcat had trouble %d\n", status);
	}	
	if(!sanottu)unlink(cachefile);
}
